import type { Disposer, PromiseMaybe, AbortSignal, OptionsHighlight, OptionsHighMate, TextMateToken } from './types';
declare class HighMate<Grammar extends string = string, Theme extends string = string> {
    private oniguruma;
    private registry;
    private tokenizer;
    constructor(options: OptionsHighMate<Grammar, Theme>);
    highlightToAbstract: <T>(options: OptionsHighlight<Grammar, Theme>, highlighter: (lines: string[], tokens: TextMateToken[][], background: string) => PromiseMaybe<T>) => Promise<T>;
    highlightToDOM: (options: OptionsHighlight<Grammar, Theme>) => Promise<HTMLPreElement>;
    highlightToHighlights: (options: OptionsHighlight<Grammar, Theme>) => Promise<[HTMLPreElement, Disposer]>;
    highlightToHTML: (options: OptionsHighlight<Grammar, Theme>) => Promise<string>;
    tokenize: (lines: string[], grammar: Grammar, theme: Theme, signal: AbortSignal | undefined, onTokens: (tokens: TextMateToken[], lineIndex: number) => void) => Promise<void>;
}
export default HighMate;
