import type { OptionsRegistry, TextMateThemeRaw } from '../types';
declare class Registry<Grammar extends string, Theme extends string> {
    private options;
    private registry;
    private theme;
    constructor(options: OptionsRegistry<Grammar, Theme>);
    fetchGrammar: (name: Grammar) => Promise<import("vscode-textmate").IRawGrammar | undefined>;
    fetchTheme: (name: Theme) => Promise<TextMateThemeRaw | undefined>;
    loadGrammar: (name: Grammar) => Promise<import("vscode-textmate").IGrammar | undefined>;
    loadTheme: (name: Theme) => Promise<TextMateThemeRaw | undefined>;
    loadThemeColors: (name: Theme) => Promise<string[]>;
    loadThemeColorsDefault: (name: Theme) => Promise<{
        background: string;
        foreground: string;
    }>;
    loadThemeDecorations: () => string[];
    loadThemeStyles: () => string[];
    normalizeTheme: (theme?: TextMateThemeRaw | undefined) => Promise<TextMateThemeRaw>;
    setTheme: (theme: TextMateThemeRaw) => void;
}
export default Registry;
